﻿declare @CustYear int = 2005
declare @CustType varchar(1) = 'F'	/*can be C...Calendar Year or F...Fiscal Year*/

select
    VE.Vendor,
    VE.Name,
    sum(case when (
			case when @CustType = 'F' 
			then cast(LedgerAP.Period % 100 as int) 
			else month(LedgerAP.TransDate) end) = 1 
        then LedgerAP.Amount 
        else 0 end) as month01,
    sum(case when (
			case when @CustType = 'F' 
			then cast(LedgerAP.Period % 100 as int) 
			else month(LedgerAP.TransDate) end) = 2 
        then LedgerAP.Amount 
        else 0 end) as month02,
    sum(case when (
			case when @CustType = 'F' 
			then cast(LedgerAP.Period % 100 as int) 
			else month(LedgerAP.TransDate) end) = 3 
        then LedgerAP.Amount 
        else 0 end) as month03,
    sum(case when (
			case when @CustType = 'F' 
			then cast(LedgerAP.Period % 100 as int) 
			else month(LedgerAP.TransDate) end) = 4 
        then LedgerAP.Amount 
        else 0 end) as month04,
    sum(case when (
			case when @CustType = 'F' 
			then cast(LedgerAP.Period % 100 as int) 
			else month(LedgerAP.TransDate) end) = 5 
        then LedgerAP.Amount 
        else 0 end) as month05,
    sum(case when (
			case when @CustType = 'F' 
			then cast(LedgerAP.Period % 100 as int) 
			else month(LedgerAP.TransDate) end) = 6 
        then LedgerAP.Amount 
        else 0 end) as month06,
    sum(case when (
			case when @CustType = 'F' 
			then cast(LedgerAP.Period % 100 as int) 
			else month(LedgerAP.TransDate) end) = 7 
        then LedgerAP.Amount 
        else 0 end) as month07,
    sum(case when (
			case when @CustType = 'F' 
			then cast(LedgerAP.Period % 100 as int) 
			else month(LedgerAP.TransDate) end) = 8 
        then LedgerAP.Amount 
        else 0 end) as month08,
    sum(case when (
			case when @CustType = 'F' 
			then cast(LedgerAP.Period % 100 as int) 
			else month(LedgerAP.TransDate) end) = 9 
        then LedgerAP.Amount 
        else 0 end) as month09,
    sum(case when (
			case when @CustType = 'F' 
			then cast(LedgerAP.Period % 100 as int) 
			else month(LedgerAP.TransDate) end) = 10 
        then LedgerAP.Amount 
        else 0 end) as month10,
    sum(case when (
			case when @CustType = 'F' 
			then cast(LedgerAP.Period % 100 as int) 
			else month(LedgerAP.TransDate) end) = 11 
        then LedgerAP.Amount 
        else 0 end) as month11,
    sum(case 
			when (case when @CustType = 'F' 
			then cast(LedgerAP.Period % 100 as int) 
			else month(LedgerAP.TransDate) end) = 12 
        then LedgerAP.Amount 
        else 0 end) as month12,
    sum(LedgerAP.Amount) as total
from
    VE
    join VendorCustomTabFields on VE.Vendor = VendorCustomTabFields.Vendor
    /*add financial information*/
    left join LedgerAP on VE.Vendor = LedgerAP.Vendor
where
	LedgerAP.TransType in ('AP', 'CV') and
	/*check for fiscal or calendar year*/
	case when @CustType = 'F' then cast(LedgerAP.Period / 100 as int) else year(LedgerAP.TransDate) end = @CustYear 
	/***EXTEND WHERE CLAUSE***/
group by 
	VE.Vendor,
    VE.Name
order by 
	VE.Vendor,
    VE.Name